Index: branches/src/ProcessManagement/ProcessManagement/Forms/Master/BankBusinessDay/FrmBBDAux.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/Master/BankBusinessDay/FrmBBDAux.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/Master/BankBusinessDay/FrmBBDAux.cs	(revision 302)
@@ -0,0 +1,635 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+using System.Collections;
+
+using ProcessManagement.Forms.CustomControls;
+using ProcessManagement.DataModel;
+using ProcessManagement.Common;
+using ProcessManagement.DB.IOAccess;
+using ProcessManagement.Forms.ControlsAction;
+
+namespace ProcessManagement.Forms.Master
+{
+    public partial class FrmBBD
+    {
+        #region 定数
+        /// <summary>
+        /// カラムポジション
+        /// </summary>
+        public static int[] s_ColumnPosision = new int[] { 3, 43, 83, 123, 163, 203, 243 };
+        /// <summary>
+        /// ロウポジション
+        /// </summary>
+        public static int[] s_RowPosision = new int[] { 0, 20, 40, 60, 80, 100, 120 };
+
+        #endregion
+
+        #region 初期ページ表示
+        /// <summary>
+        /// 初期ページ表示
+        /// </summary>
+        private void InitCreatePage()
+        {
+            try
+            {
+                m_CalendPage.lblMonthTitle[0] = lblMonth01;
+                m_CalendPage.lblMonthTitle[1] = lblMonth02;
+                m_CalendPage.lblMonthTitle[2] = lblMonth03;
+                m_CalendPage.lblMonthTitle[3] = lblMonth04;
+                m_CalendPage.lblMonthTitle[4] = lblMonth05;
+                m_CalendPage.lblMonthTitle[5] = lblMonth06;
+                m_CalendPage.lblMonthTitle[6] = lblMonth07;
+                m_CalendPage.lblMonthTitle[7] = lblMonth08;
+                m_CalendPage.lblMonthTitle[8] = lblMonth09;
+                m_CalendPage.lblMonthTitle[9] = lblMonth10;
+                m_CalendPage.lblMonthTitle[10] = lblMonth11;
+                m_CalendPage.lblMonthTitle[11] = lblMonth12;
+
+                // 12カ月処理する
+                int MonthTitleMax = m_CalendPage.lblMonthTitle.Length;
+                for (int i = 0; i < MonthTitleMax; i++)
+                {
+                    m_CalendPage.MonthTableLayout[i] = new TableLayoutPanel();
+                    m_CalendPage.MonthryData[i] = new MonthryData();
+
+                    // 1カ月分処理する
+                    int RowPosisionMax = s_RowPosision.Length;
+                    for (int iy = 0; iy < RowPosisionMax; iy++)
+                    {
+                        // 1週間分処理する
+                        int ColumnPosisionMax = s_ColumnPosision.Length;
+                        for (int ix = 0; ix < ColumnPosisionMax; ix++)
+                        {
+                            //　ラベルの設定
+                            switch (iy)
+                            {
+                                case 0:
+                                    m_CalendPage.MonthryData[i].lblWeekTitle[ix] = new Label();
+                                    // 曜日表示
+                                    m_CalendPage.MonthryData[i].lblWeekTitle[ix].Text = CommonDefine.DayOfTheWeekString[ix];
+                                    m_CalendPage.MonthryData[i].lblWeekTitle[ix].TextAlign = ContentAlignment.MiddleCenter;
+
+                                    break;
+                                default:
+                                    int wrkIY = iy - 1;
+                                    m_CalendPage.MonthryData[i].lblDayData[ix + (wrkIY * 7)] = new Label();
+                                    // 日表示
+                                    m_CalendPage.MonthryData[i].lblDayData[ix + (wrkIY * 7)].TextAlign = ContentAlignment.MiddleRight;
+                                    m_CalendPage.MonthryData[i].lblDayData[ix + (wrkIY * 7)].DoubleClick += new System.EventHandler(this.lblDayData_DoubleClick);
+
+                                    break;
+                            }
+                        }
+                    }
+                }
+
+                //
+                // MonthTableLayout
+                // 
+                int CalendPageMax = m_CalendPage.MonthTableLayout.Length;
+                for (int i = 0; i < CalendPageMax; i++)
+                {
+                    m_CalendPage.MonthTableLayout[i].BackColor = System.Drawing.Color.White;
+                    m_CalendPage.MonthTableLayout[i].ColumnCount = 7;
+                    m_CalendPage.MonthTableLayout[i].ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 40F));
+                    m_CalendPage.MonthTableLayout[i].ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 40F));
+                    m_CalendPage.MonthTableLayout[i].ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 40F));
+                    m_CalendPage.MonthTableLayout[i].ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 40F));
+                    m_CalendPage.MonthTableLayout[i].ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 40F));
+                    m_CalendPage.MonthTableLayout[i].ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 40F));
+                    m_CalendPage.MonthTableLayout[i].ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 40F));
+                    for (int iy = 0; iy < 7; iy++)
+                    {
+                        for (int ix = 0; ix < 7; ix++)
+                        {
+                            switch (iy)
+                            {
+                                case 0:
+                                    m_CalendPage.MonthTableLayout[i].Controls.Add(m_CalendPage.MonthryData[i].lblWeekTitle[ix], ix, iy);
+                                    break;
+                                default:
+                                    int wrkIY = iy - 1;
+                                    m_CalendPage.MonthTableLayout[i].Controls.Add(m_CalendPage.MonthryData[i].lblDayData[ix + (wrkIY * 7)], ix, iy);
+                                    break;
+                            }
+                        }
+                    }
+                    m_CalendPage.MonthTableLayout[i].Location = new System.Drawing.Point(m_CalendPage.lblMonthTitle[0].Location.X, m_CalendPage.lblMonthTitle[0].Location.Y + 23);
+                    m_CalendPage.MonthTableLayout[i].Name = "MonthTableLayout" + i.ToString("00");
+                    m_CalendPage.MonthTableLayout[i].RowCount = 7;
+                    m_CalendPage.MonthTableLayout[i].RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+                    m_CalendPage.MonthTableLayout[i].RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+                    m_CalendPage.MonthTableLayout[i].RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+                    m_CalendPage.MonthTableLayout[i].RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+                    m_CalendPage.MonthTableLayout[i].RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+                    m_CalendPage.MonthTableLayout[i].RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+                    m_CalendPage.MonthTableLayout[i].RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+                    m_CalendPage.MonthTableLayout[i].Size = new System.Drawing.Size(278, 138);
+                    m_CalendPage.MonthTableLayout[i].TabIndex = 8;
+
+                    int iXPoint = 0;
+                    int iYPoint = 0;
+                    GetMonthTabTableLayoutPoint(i, ref iXPoint, ref iYPoint);
+
+                    this.tableLayoutPanel1.Controls.Add(m_CalendPage.MonthTableLayout[i], iXPoint, iYPoint);
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 月別レイアウトテーブル位置取得
+        /// <summary>
+        /// 月別レイアウトテーブル位置取得
+        /// </summary>
+        /// <param name="Count"></param>
+        /// <param name="iXPoint"></param>
+        /// <param name="iYPoint"></param>
+        private void GetMonthTabTableLayoutPoint(int Count, ref int iXPoint, ref int iYPoint)
+        {
+            switch (Count)
+            {
+                case 0:
+                    iXPoint = 0; iYPoint = 1;
+                    break;
+                case 1:
+                    iXPoint = 1; iYPoint = 1;
+                    break;
+                case 2:
+                    iXPoint = 2; iYPoint = 1;
+                    break;
+                case 3:
+                    iXPoint = 3; iYPoint = 1;
+                    break;
+                case 4:
+                    iXPoint = 0; iYPoint = 3;
+                    break;
+                case 5:
+                    iXPoint = 1; iYPoint = 3;
+                    break;
+                case 6:
+                    iXPoint = 2; iYPoint = 3;
+                    break;
+                case 7:
+                    iXPoint = 3; iYPoint = 3;
+                    break;
+                case 8:
+                    iXPoint = 0; iYPoint = 5;
+                    break;
+                case 9:
+                    iXPoint = 1; iYPoint = 5;
+                    break;
+                case 10:
+                    iXPoint = 2; iYPoint = 5;
+                    break;
+                case 11:
+                    iXPoint = 3; iYPoint = 5;
+                    break;
+            }
+
+        }
+        #endregion
+
+        #region 画面クリア
+        /// <summary>
+        /// 画面クリア
+        /// </summary>
+        private void ClearCalender()
+        {
+            try
+            {
+                tableLayoutPanel1.SuspendLayout();
+
+                // 12カ月処理する
+                for (int i = 0; i < m_CalendPage.lblMonthTitle.Length; i++)
+                {
+                    m_CalendPage.lblMonthTitle[i].Text = "";
+
+                    for (int ix = 0; ix < m_CalendPage.MonthryData[i].lblDayData.Length; ix++)
+                    {
+                        m_CalendPage.MonthryData[i].lblDayData[ix].Text = "";
+
+                        m_CalendPage.MonthryData[i].lblDayData[ix].BackColor = Color.White;
+                    }
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 新規カレンダー作成表示
+        /// <summary>
+        /// 新規カレンダー作成表示
+        /// </summary>
+        private void CreateNewCalender(bool bNoneData)
+        {
+            try
+            {
+                // 表示クリア
+                ClearCalender();
+
+                // 設定年月日作成
+                string CalenderDate = string.Format("{0}/{1}", numUDYear.Value, "01/01");
+                DateTime wrkStartDate = CommonMotions.cnvDate(CalenderDate);
+
+                tableLayoutPanel1.SuspendLayout();
+
+                // 12カ月処理する
+                for (int i = 0; i < m_CalendPage.lblMonthTitle.Length; i++)
+                {
+                    // 月をセットする
+                    string CurDate = wrkStartDate.AddMonths(i).ToShortDateString();
+                    string CurYear = CurDate.Substring(0, CurDate.IndexOf("/"));
+                    string CurMonth = CurDate.Substring(CurDate.IndexOf("/") + 1, 2);
+                    m_CalendPage.lblMonthTitle[i].Text = CurYear + "年" + CurMonth + "月";
+
+                    // 日付の開始位置と週数を求める
+                    int XStart = 0;
+                    int YEnd = s_RowPosision.Length;
+
+                    // 月の最終日から週数を求める
+                    int mlength = DateTime.DaysInMonth(CommonMotions.cnvInt(CurYear), CommonMotions.cnvInt(CurMonth));
+                    CurDate = CurYear + "/" + CurMonth + "/" + mlength.ToString("00");
+                    YEnd = CommonMotions.NthWeek(CommonMotions.cnvDate(CurDate));
+
+                    // 開始日の曜日から開始位置を求める
+                    XStart = (int)wrkStartDate.AddMonths(i).DayOfWeek;
+
+                    // 1カ月分処理する
+                    int iDay = 1;
+                    for (int iy = 0; iy < YEnd; iy++)
+                    {
+                        // 1週目以外は最初から始める
+                        if (iy != 0) XStart = 0;
+
+                        // 1週間分処理する
+                        for (int ix = XStart; ix < s_ColumnPosision.Length; ix++)
+                        {
+                            // 月の最終日まで処理を行う
+                            if (iDay > mlength) break;
+                            // 日付セット
+                            m_CalendPage.MonthryData[i].lblDayData[ix + (iy * 7)].Text = iDay.ToString();
+                            
+                            // 会社営業日データが無い場合はここで営業日設定
+                            if (bNoneData)
+                            {
+                                DateTime dtweek = CommonMotions.cnvDate(CurYear + "/" + CurMonth + "/" + iDay.ToString("00"));
+                                DayOfWeek dayofweek = dtweek.DayOfWeek;
+                                if (dayofweek == DayOfWeek.Sunday)
+                                {
+                                    m_CalendPage.MonthryData[i].lblDayData[ix + (iy * 7)].BackColor = Color.Red;
+                                }
+                                else if (dayofweek == DayOfWeek.Saturday)
+                                {
+                                    m_CalendPage.MonthryData[i].lblDayData[ix + (iy * 7)].BackColor = Color.Red;
+                                }
+                            }
+                            iDay++;     // 月日数
+                        }
+                    }
+                }
+
+                tableLayoutPanel1.ResumeLayout();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region カレンダー表示
+        /// <summary>
+        /// カレンダー表示
+        /// </summary>
+        private void DisplayCalender()
+        {
+            IOBankBusinessDayMaster bbdDB = new IOBankBusinessDayMaster();
+            try
+            {
+                StringBuilder wrkSQL = new StringBuilder();
+                wrkSQL.Append("SELECT");
+                wrkSQL.Append(" Count(*)");
+                wrkSQL.Append(" FROM bankbusinessdaymaster");
+                wrkSQL.Append(" Where");
+                wrkSQL.AppendFormat(" truncate (YEARMONTH / 100, 0) = {0}", numUDYear.Value);
+                ArrayList arData = new ArrayList();
+
+                // SQL実行
+                if (!bbdDB.ExecuteReader(wrkSQL.ToString(), ref arData, true)) return;
+                if (arData.Count == 0) return;
+
+                // データセット
+                object[] objwrk = (object[])arData[0];
+                // 営業日カレンダーデータがある場合
+                if (CommonMotions.cnvInt(objwrk[0]) != 0)
+                {
+                    CreateNewCalender(false);
+                    CalenderDataLoad();
+                }
+                else
+                {
+                    CreateNewCalender(true);
+                }
+
+
+                m_bChengeAns = false;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                bbdDB.close(); bbdDB = null;
+            }
+        }
+        #endregion
+
+        #region カレンダー表示
+        /// <summary>
+        /// カレンダー表示
+        /// </summary>
+        private void CalenderDataLoad()
+        {
+            IOBankBusinessDayMaster bbdDB = new IOBankBusinessDayMaster();
+            try
+            {
+                int MonthCnt = m_CalendPage.lblMonthTitle.Length;
+                for (int i = 0; i < MonthCnt; i++)
+                {
+                    if (m_CalendPage.lblMonthTitle[i].Text.Length == 0) continue;
+
+                    // 該当年を検索する
+                    string nen = m_CalendPage.lblMonthTitle[i].Text.Substring(0, m_CalendPage.lblMonthTitle[i].Text.IndexOf("年"));
+                    int tergetYear = CommonMotions.cnvInt(nen);
+                    // 該当月を検索する
+                    string wrkTuki = m_CalendPage.lblMonthTitle[i].Text.Substring(m_CalendPage.lblMonthTitle[i].Text.IndexOf("年") + 1, 2);
+                    int tergetMonth = CommonMotions.cnvInt(wrkTuki);
+
+                    StringBuilder strGetMonth = new StringBuilder();
+                    strGetMonth.Append("SELECT");
+                    strGetMonth.Append(" t1.d");
+                    strGetMonth.Append(", CONCAT(");
+                    strGetMonth.Append("truncate (C.YEARMONTH / 100, 0)");
+                    strGetMonth.Append(", '/'");
+                    strGetMonth.Append(", lpad(mod(C.YEARMONTH, 100), 2, 0)");
+                    strGetMonth.Append(", '/'");
+                    strGetMonth.Append(", lpad(C.BANKBUSINESSDAY, 2, 0)");
+                    strGetMonth.Append(") AS BusDAY");
+                    strGetMonth.Append(" FROM");
+                    strGetMonth.Append(" (");
+                    strGetMonth.Append(" SELECT");
+                    strGetMonth.Append(" A1.years");
+                    strGetMonth.Append(", A2.month");
+                    strGetMonth.Append(", A3.days");
+                    strGetMonth.Append(", CAST(");
+                    strGetMonth.Append(" CONCAT(A1.years, '/', A2.month, '/', A3.days) as DATE");
+                    strGetMonth.Append(") as d");
+                    strGetMonth.Append(" FROM");
+                    strGetMonth.Append(" yearmaster as A1");
+                    strGetMonth.Append(", monthmaster as A2");
+                    strGetMonth.Append(", daymaster as A3");
+                    strGetMonth.AppendFormat(" WHERE A1.years = {0}", tergetYear);
+                    strGetMonth.AppendFormat(" AND A2.month = {0}", tergetMonth);
+                    strGetMonth.Append(" AND CAST(CONCAT(A1.years, '/', A2.month, '/', A3.days) as DATE) IS NOT NULL) t1");
+                    strGetMonth.Append(" LEFT JOIN bankbusinessdaymaster C ON ((C.YEARMONTH * 100) + C.BANKBUSINESSDAY) = t1.d");
+                    strGetMonth.Append(" ORDER BY t1.d"); 
+
+                    ArrayList dataList = new ArrayList();
+                    if (!bbdDB.ExecuteReader(strGetMonth.ToString(), ref dataList)) continue;
+                    if (dataList.Count == 0) continue;
+
+                    int lblDayCnt = m_CalendPage.MonthryData[i].lblDayData.Length;
+                    object[] CurData = null;
+                    for (int ix = 0; ix < lblDayCnt; ix++)
+                    {
+                        if (m_CalendPage.MonthryData[i].lblDayData[ix].Text.Length == 0) continue;
+
+                        // ラベルの日付より取得データの位置を取る
+                        int daycnt = CommonMotions.cnvInt(m_CalendPage.MonthryData[i].lblDayData[ix].Text) - 1;
+                        CurData = (object[])dataList[daycnt];
+                        if (CommonMotions.cnvDate(CurData[1]) == DateTime.MinValue)
+                        {
+                            m_CalendPage.MonthryData[i].lblDayData[ix].BackColor = Color.Red;
+                        }
+                    }
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                bbdDB.close(); bbdDB = null;
+            }
+        }
+        #endregion
+
+        #region 営業日を登録する
+        /// <summary>
+        /// 営業日を登録する
+        /// </summary>
+        private bool BusinesCalenderEntry()
+        {
+            IOBankBusinessDayMaster bbdDB = new IOBankBusinessDayMaster();
+            try
+            {
+                bbdDB.connect();
+                bbdDB.beginTran();
+
+                // まず削除する
+                string wrkSQL = string.Format(" Where Truncate(YEARMONTH / 100, 0) = {0}", numUDYear.Value);
+                // データ削除
+                bbdDB.DeleteAction(wrkSQL, false);
+
+
+                List<BankBusinessDayMaster> DataList = new List<BankBusinessDayMaster>();
+                // 設定年月日作成
+                string CalenderDate = string.Format("{0}01", m_CalendPage.lblMonthTitle[0].Text.Replace("年", "/").Replace("月", "/"));
+                DateTime wrkStartDate = CommonMotions.cnvDate(CalenderDate);
+                // 12カ月処理する
+                for (int i = 0; i < m_CalendPage.lblMonthTitle.Length; i++)
+                {
+                    // 月をセットする
+                    string CurDate = wrkStartDate.AddMonths(i).ToShortDateString();
+                    string CurYear = CurDate.Substring(0, CurDate.IndexOf("/"));
+                    string CurMonth = CurDate.Substring(CurDate.IndexOf("/") + 1, 2);
+                    // 月の最終日から週数を求める
+                    int mlength = DateTime.DaysInMonth(CommonMotions.cnvInt(CurYear), CommonMotions.cnvInt(CurMonth));
+
+                    // 1週間分処理する
+                    for (int ix = 0; ix < m_CalendPage.MonthryData[i].lblDayData.Length; ix++)
+                    {
+                        // 月の最終日まで処理を行う
+                        if (m_CalendPage.MonthryData[i].lblDayData[ix].Text.Length == 0)
+                            continue;
+                        // 営業日を加算する
+                        if (m_CalendPage.MonthryData[i].lblDayData[ix].BackColor == Color.Red) continue;
+
+                        BankBusinessDayMaster wrkRec = new BankBusinessDayMaster();
+                        wrkRec.YearMonth = (CommonMotions.cnvInt(CurYear) * 100) + CommonMotions.cnvInt(CurMonth);          // 年月
+                        wrkRec.BankBusinessDay = CommonMotions.cnvInt(m_CalendPage.MonthryData[i].lblDayData[ix].Text);     // 銀行営業日
+
+                        DataList.Add(wrkRec);
+                    }
+                }
+                if (!bbdDB.InsertAction(DataList, false))
+                {
+                    bbdDB.rollback();
+                    MessageBox.Show("登録に失敗しました。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+
+                bbdDB.commit();
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                bbdDB.close(); bbdDB = null;
+            }
+        }
+        #endregion
+
+        #region 画面項目のチェック
+        /// <summary>
+        /// 画面項目のチェック
+        /// </summary>
+        /// <returns></returns>
+        private bool DispFeildCheck()
+        {
+            try
+            {
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 対象年度セット
+        /// <summary>
+        /// 対象年度セット
+        /// </summary>
+        private void SetnumUDYear()
+        {
+            IOBankBusinessDayMaster calDB = new IOBankBusinessDayMaster();
+            try
+            {
+                // 当年度取得
+                int ToYear = CommonMotions.SystemMasterData.ConstructionYear;
+
+                StringBuilder strSQL = new StringBuilder();
+                strSQL.Append("SELECT");
+                strSQL.Append(" Truncate (YEARMONTH / 100, 0)");
+                strSQL.Append(", COUNT(*)");
+                strSQL.Append(" FROM");
+                strSQL.Append(" bankbusinessdaymaster");
+                strSQL.Append(" GROUP BY");
+                strSQL.Append(" Truncate (YEARMONTH / 100, 0)");
+                strSQL.Append(" ORDER BY");
+                strSQL.Append(" Truncate (YEARMONTH / 100, 0)");
+
+                ArrayList arList = new ArrayList();
+                int Max = 0;
+                int Min = 0;
+                if (calDB.ExecuteReader(strSQL.ToString(), ref arList) || arList.Count != 0)
+                {
+                    // 最大・最低値取得
+                    GetMaxMinYear(arList, ref Max, ref Min);
+                    if (Max < ToYear) Max = ToYear;
+                }
+                else
+                {
+                    Max = ToYear;
+                    Min = ToYear;
+                }
+                if (Max <= DateTime.Now.Year) ++Max;
+
+                // 最大・最低値セット
+                numUDYear.Minimum = Min;
+                numUDYear.Maximum = Max;
+                numUDYear.Value = ToYear;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                calDB.close(); calDB = null;
+            }
+        }
+        #endregion
+
+        #region 配列より最大値・最低値を取得する
+        /// <summary>
+        /// 配列より最大値・最低値を取得する
+        /// </summary>
+        /// <param name="arList"></param>
+        /// <param name="Max"></param>
+        /// <param name="Min"></param>
+        private void GetMaxMinYear(ArrayList arList, ref int Max, ref int Min)
+        {
+            try
+            {
+                bool init = true;
+                foreach (object[] wrkobj in arList)
+                {
+                    if (init)
+                    {
+                        Min = CommonMotions.cnvInt(wrkobj[0]);
+                        init = false;
+                    }
+                    Max = CommonMotions.cnvInt(wrkobj[0]);
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 参照時ロック処理
+        /// <summary>
+        /// 参照時ロック処理
+        /// </summary>
+        private void ExecReadOnly()
+        {
+            try
+            {
+                btnDataEntry.Visible = false;
+                btnDataDelete.Visible = false;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+    }
+}
Index: branches/src/ProcessManagement/ProcessManagement/Forms/Master/Calender/FrmCalendarAuxiliary.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/Master/Calender/FrmCalendarAuxiliary.cs	(revision 301)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/Master/Calender/FrmCalendarAuxiliary.cs	(revision 302)
@@ -604,8 +604,6 @@
                 // 当年度取得
                 int ToYear = CommonMotions.SystemMasterData.ConstructionYear;
 
-                //string strSQL = "SELECT TO_CHAR(Holiday ,'YYYY'), COUNT(*) FROM HOLIDAYCALENDERMASTER";
-                //strSQL += " GROUP BY TO_CHAR(Holiday ,'YYYY') ORDER BY TO_CHAR(Holiday ,'YYYY')";
                 string strSQL = "SELECT DATE_FORMAT(Holiday ,'%Y'), COUNT(*) FROM HOLIDAYCALENDERMASTER";
                 strSQL += " GROUP BY DATE_FORMAT(Holiday ,'%Y') ORDER BY DATE_FORMAT(Holiday ,'%Y')";
 
@@ -623,6 +621,8 @@
                     Max = ToYear;
                     Min = ToYear;
                 }
+
+                if (Max <= DateTime.Now.Year) ++Max;
                 // 最大・最低値セット
                 numUDYear.Minimum = Min;
                 numUDYear.Maximum = Max;
Index: branches/src/ProcessManagement/ProcessManagement/Forms/Master/Security/FrmSecurity.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/Master/Security/FrmSecurity.cs	(revision 301)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/Master/Security/FrmSecurity.cs	(revision 302)
@@ -171,6 +171,7 @@
                                                     new KeyValuePair<int, string>((int)ClsExcute.MaintenanceExecuteNo.MaterialKind, string.Empty),          // 資材種類登録
                                                     new KeyValuePair<int, string>((int)ClsExcute.MaintenanceExecuteNo.MaterialItem, string.Empty),          // 資材品目登録
                                                     new KeyValuePair<int, string>((int)ClsExcute.MaintenanceExecuteNo.SalesConfirm, string.Empty),          // 売上確認
+                                                    new KeyValuePair<int, string>((int)ClsExcute.MaintenanceExecuteNo.BankBusinessDay, string.Empty),       // 銀行営業日登録
                                                                         };
         #endregion
         #endregion
Index: branches/src/ProcessManagement/ProcessManagement/Forms/ZMenu/FrmMenu.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/ZMenu/FrmMenu.cs	(revision 301)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/ZMenu/FrmMenu.cs	(revision 302)
@@ -718,7 +718,7 @@
                                                                     (int)ClsExcute.MaintenanceExecuteNo.MaterialKind,
                                                                     (int)ClsExcute.MaintenanceExecuteNo.MaterialItem
                                                                 },
-                                                                { 0,
+                                                                { (int)ClsExcute.MaintenanceExecuteNo.BankBusinessDay,
                                                                     0,
                                                                     0,
                                                                     (int)ClsExcute.MaintenanceExecuteNo.SalesConfirm
